// Diffuse GLSL Vertex Shader
// Written by Florian Rudolf (corrail@gmx.at)
// Copyright (c) 2004; All right reserved

uniform vec3 lightPosition0;

attribute vec3 a2v_Normal;
attribute vec2 a2v_Texcoord;

varying vec3 v2f_Normal;
varying vec3 v2f_LightVec;
varying vec2 v2f_Texcoord;

void main()
{
	// Vertex transformation
	gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;

	// Calculation Light vector in ModelView Space
	v2f_LightVec = vec3(gl_LightSource[0].position - gl_ModelViewMatrix * gl_Vertex);
	
	// Normal transformation
	v2f_Normal = gl_NormalMatrix * a2v_Normal;
	
	v2f_Texcoord = a2v_Texcoord;
}